from abc import ABC
from typing import Union,List
from containers.spans import SpanGroup

class EntityLinker(ABC):
    def __call__(self,documents):
        #Identifies spans and labels them with their corresponding entity. 
        raise NotImplementedError
        

class ContextlessLinker(EntityLinker):
    def __call__(self,documents):
        span_groups = self.get_spans(documents)
        #TODO Need to be able to batch spans from all spangroups. Flatten -> Map -> Unflatten
        for i,document in enumerate(documents):
            concept_ids = self.link_texts([span.text for span in span_groups[i]])
            document.entities.set_lkb_ids(concept_ids)
    def link_texts(self,texts) -> Union[List[str],str]:
        #returns a list of concept_ids
        if type(texts) == List:
            return self._link_texts(self,texts)
        elif type(texts) == str:
            return self._link_texts(self,[texts])[0]
    def _link_texts(self,texts)->List[str]:
        raise NotImplementedError
    def get_span_groups(self,documents) -> List[SpanGroup]:
        #returns the span groups to be linked to the lkb entities. 
        raise NotImplementedError



