import pytest
from lkb.basic_lkb import Basic_Lexical_Knowledge_Base
from components.entity_linkers.ngram_no_context_linker.ngram_text_linker import ngramEntityLinker
# from nlp_framework.components.entity_linkers.ngram_no_context_linker import LINKER_PATHS,ngramEntityLinker


@pytest.fixture
def small_lkb():
    return Basic_Lexical_Knowledge_Base.read_json("small_lkb_example.json")
    

@pytest.fixture
def linker(small_lkb):
    ann_index, tfidf_vectorizer, term_ids = ngramEntityLinker.create_index(small_lkb,"dummy_linker_path",min_df=1)
    return ngramEntityLinker(ann_index,tfidf_vectorizer,term_ids,lkb=small_lkb)

def test_linking(linker):
    linked_concept_ids = linker.link_texts(["bank","bank robber","happiness","joyfil","delight","jubilation"])
    expected = [
                ['financial institution concept', 'side of river concept'],
                ['financial institution concept', 'side of river concept'],
                ['elated emotion concept'],
                ['elated emotion concept'],
                ['elated emotion concept'],
                ['elated emotion concept'],
    ]
    assert linked_concept_ids == expected
