class Span:#Only let document initialize this class
    def __init__(self,document,start_index,end_index,concept_id=None):
        self._doc = document
        self._start_index = start_index
        self._end_index = end_index
        self._lkb_id = concept_id
    @property
    def data(self):
        return {"start_index":self._start_index,"end_index":self._end_index,"concept_id":self._concept_id}
    @property
    def text(self):
        return self._doc.message[self._start_index:self._end_index]
    @property
    def start_index(self):
        return self._start_index
    @property
    def end_index(self):
        return self._end_index
    @property
    def concept_id(self):
        return self._lkb_id
    # @property
    # def concept_name(self,lkb=None):
    #     return lkb.get_terms_from_concept_id(self.concept_id)[0].string
    @property
    def doc(self):
        return self._doc
    def set_lkb_id(self,concept_id):
        self._lkb_id = concept_id
    def __repr__(self):
        return str({"start_index":self.start_index,"end_index":self.end_index,"concept_id":self.concept_id,"text":self.text})

class SpanGroup:
    def __init__(self,span_list=None):
        if span_list == None:
            self._spans = []
        else:
            self._spans = span_list
    def data(self):
        return [span.data for span in self._spans]
    def check_for_span_overlaps(self):
        for span_1 in self._spans:
            for span_2 in self._spans:
                if span_1.start_index >= span_2.start_index and span_1.end_index <= span_2.end_index and span_1 != span_2:
                    return True
        return False
    def remove_overlaps(self,broad_strategy:bool=True):
        if broad_strategy:
            no_overlap_span_data = []
            for span_1 in self._spans:
                contained=False
                for span_2 in self._spans:
                    if span_1.start_index >= span_2.start_index and span_1.end_index <= span_2.end_index and span_1 != span_2:
                        contained = True
                if not contained:
                    no_overlap_span_data.append(span_1)
            return SpanGroup(no_overlap_span_data)
        else:
            raise NotImplementedError
    def set_lkb_ids(self,concept_ids):
        for i,span in enumerate(self._spans):
            span.set_lkb_id(concept_ids[i])
    @classmethod
    def from_dicts(cls,span_dicts):
        return cls(Span(**span_dict) for span_dict in span_dicts)

